// MDeadMatch.cpp: implementation of the MDeadMatch class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "D3DXApp.h"
#include "MDeadMatch.h"
#include "GFile.h"
#include "MainFrm.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

const int bonuslevel[][2] = 
{
	{2, 0}, // smrt
	{1, 0}, // bomba
	{0, 0}, // plamen
	{3, 0}, // botasky
	{4, 0}, // odpalovac
	{0, 1}, // megabomba
	{3, 1}, // kopacky
	{1, 2}, // napalm
	{0, 2}, // posilani
	{2, 1}, // stit
	{1, 1}, // zivot
	{4, 1}, // nemoc ostatni
	{2, 2}, // fireman
};

MDeadMatch::MDeadMatch()
{
	m_anim = 0;
	m_players = 2;
	m_monsters = true;
	m_sel = 0;
	m_victories = 3;
	m_bonuslevel = MAX_BONUS_LEVEL_DEADMATCH; //8-18;


	m_files = 0;
	m_ID = 0;


	CreateFileList();


	char c[255];
	CString s;
	
	GetCurrentDirectory(255, c);

	s.Format("%s", c);
	s += "\\maps";
	SetCurrentDirectory(s);
	CreateFileList();

	SetCurrentDirectory(c);


}

MDeadMatch::~MDeadMatch()
{

}

void MDeadMatch::Init(CMainFrame *parent)
{
	GBase::Init(parent);

	m_bDeadBMP = d3dx.CreateTextureFromRes(gfx_modules, "menudead.bmp");
	m_bDead = d3dx.CreateVirualTexture(m_bDeadBMP, 1, 1, 50, 70);

	m_bMenuDead = d3dx.CreateTextureFromFile("data\\mdead.jpg");

	for (int i = 0; i < MAX_MAPS; i++) {
		CString s;
		s.Format("DM%d.bmp", i);
		m_bDeadMap[i] = d3dx.CreateTextureFromRes(gfx_modules, s);
	}

	m_bDeadBonusBMP = d3dx.CreateTextureFromRes(gfx_modules, "bonusy.bmp");
	m_bDeadBonus  = d3dx.CreateVirualTexture(m_bDeadBonusBMP, 1, 1, 50, 50);
}

void MDeadMatch::Draw()
{
	int i;

	d3dx.Draw(m_bMenuDead, 400, 300, 0, 1.5625);

	if (m_filelist[m_ID].pozadi > 2)
		d3dx.Draw(m_bDeadMap[0], 400, 190);
	else
		d3dx.Draw(m_bDeadMap[m_filelist[m_ID].pozadi], 400, 190);
	
/*
	for (i = 0; i < m_players; i++)
		d3dx.Draw(m_bDead, 300+i*60, 190, 0, 0.5, 0.5, 128, 0, 1);
	for (i = 0; i < m_players; i++)
		d3dx.Draw(m_bDead, 300+i*60, 190, 0, 0.5, 0.5, 255, i);

	if (m_monsters) {
		d3dx.Draw(m_bDead, 300, 230, 0, 0.5, 0.5, 128, 1, 1);
		d3dx.Draw(m_bDead, 300, 230, 0, 0.5, 0.5, 255, 4);
	}
	else {
		d3dx.Draw(m_bDead, 550, 230, 0, 0.5, 0.5, 128, 1, 1);
		d3dx.Draw(m_bDead, 550, 230, 0, 0.5, 0.5, 255, 3, 1);
	}

	for (i = 0; i < m_victories; i++)
		d3dx.Draw(m_bDead, 280+i*30, 140, 0, 0.5, 0.5, 255, 2, 1);
*/

#define FACTOR 1

	for (i = 0; i < m_players; i++)
		d3dx.Draw(m_bDead, 285+i*58*FACTOR, 190, 0, FACTOR, FACTOR, 128, 0, 1);
	for (i = 0; i < m_players; i++)
		d3dx.Draw(m_bDead, 285+i*58*FACTOR, 190, 0, FACTOR, FACTOR, 255, i);

	if (m_monsters) {
		d3dx.Draw(m_bDead, 520, 195, 0, FACTOR, FACTOR, 128, 1, 1);
		d3dx.Draw(m_bDead, 520, 195, 0, FACTOR, FACTOR, 255, 4);
	}
	else {
		d3dx.Draw(m_bDead, 520, 195, 0, FACTOR, FACTOR, 128, 1, 1);
		d3dx.Draw(m_bDead, 520, 195, 0, FACTOR, FACTOR, 255, 3, 1);
	}

	for (i = 0; i < m_victories; i++)
		d3dx.Draw(m_bDead, 280+i*30, 140, 0, 0.75, 0.75, 255, 2, 1);


	for (i = 5; i < m_bonuslevel; i++)
		d3dx.Draw(m_bDeadBonus, 277+(i-5)*20, 240, 0, 1, 1, 255, bonuslevel[i-5][0], bonuslevel[i-5][1]);
//	d3dx.Draw(m_bDead, 285+i*30, 240, 0, 0.5, 0.5, 255, 4, 1);



	if (m_sel == 0) m_font->DrawTextScaled( 400, 290,  0.9f, 1, 1, 0xffffffff, _LNG_DEADMATCH_START_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 290,  0.9f, 1, 1, 0xffaaaaaa, _LNG_DEADMATCH_START_, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 1) m_font->DrawTextScaled( 400, 321,  0.9f, 1, 1, 0xffffffff, m_filelist[m_ID].file, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 321,  0.9f, 1, 1, 0xffaaaaaa, m_filelist[m_ID].file, D3DFONT_FILTERED | D3DFONT_CENTERED);


	if (m_sel == 2) m_font->DrawTextScaled( 400, 353,  0.9f, 1, 1, 0xffffffff, _LNG_DEADMATCH_PLAYERS_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 353,  0.9f, 1, 1, 0xffaaaaaa, _LNG_DEADMATCH_PLAYERS_, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 3) m_font->DrawTextScaled( 400, 384,  0.9f, 1, 1, 0xffffffff, _LNG_DEADMATCH_MONSTERS_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 384,  0.9f, 1, 1, 0xffaaaaaa, _LNG_DEADMATCH_MONSTERS_, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 4) m_font->DrawTextScaled( 400, 415,  0.9f, 1, 1, 0xffffffff, _LNG_DEADMATCH_VICTORIES_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 415,  0.9f, 1, 1, 0xffaaaaaa, _LNG_DEADMATCH_VICTORIES_, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 5) m_font->DrawTextScaled( 400, 446,  0.9f, 1, 1, 0xffffffff, _LNG_DEADMATCH_BONUSLEVEL_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 446,  0.9f, 1, 1, 0xffaaaaaa, _LNG_DEADMATCH_BONUSLEVEL_, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 6) m_font->DrawTextScaled( 400, 480,  0.9f, 1, 1, 0xffffffff, _LNG_DEADMATCH_BACK_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 480,  0.9f, 1, 1, 0xffaaaaaa, _LNG_DEADMATCH_BACK_, D3DFONT_FILTERED | D3DFONT_CENTERED);

}

void MDeadMatch::Destroy()
{
	d3dx.DestroyTexture(m_bMenuDead);
	d3dx.DestroyTexture(m_bDeadBMP);
	d3dx.DestroyTexture(m_bDead);
	d3dx.DestroyTexture(m_bDeadBonus);
	d3dx.DestroyTexture(m_bDeadBonusBMP);

	for (int i = 0; i < MAX_MAPS; i++)
		d3dx.DestroyTexture(m_bDeadMap[i]);
}

void MDeadMatch::CreateFileList()
{
   CFileFind finder;
	GFile     gfile;
	st_map    map;

   BOOL bWorking = finder.FindFile("*.ble");
   while (bWorking)
   {
      bWorking = finder.FindNextFile();
		gfile.LoadMap(&map, finder.GetFileName());
		if (map.deadmach) {
			m_filelist[m_files].file = finder.GetFileName();
			m_filelist[m_files].pozadi = map.podklad;
			m_files++;
		}
   }
}

int MDeadMatch::OnKey(int nChar)
{
	switch (nChar) {
	case 40 : if (++m_sel > MAX_DEAD_SEL-1) m_sel = 0;  g_sb[0].Play(); break;
	case 38 : if (--m_sel < 0) m_sel = MAX_DEAD_SEL-1;  g_sb[0].Play(); break;
	case 27 : return MENU_MAIN; break;
	case VK_SPACE :
	case 13 : 
		switch (m_sel) {
		case 0 : return MENU_DEADMATCHING; break;
		case 1 : g_sb[0].Play(); if (++m_ID >= m_files) m_ID = 0; break;
		case 2 : g_sb[0].Play(); if (++m_players > 4) m_players = 2; break;
		case 3 : g_sb[0].Play(); m_monsters = !m_monsters; break;
		case 4 : g_sb[0].Play(); if (++m_victories >  9) m_victories = 1; break;
		case 5 : g_sb[0].Play(); if (++m_bonuslevel > MAX_BONUS_LEVEL_DEADMATCH) m_bonuslevel = 8; break;
		case 6 : return MENU_MAIN; break;
		}
		break;
	case VK_LEFT :
		switch (m_sel) {
		case 1 : g_sb[0].Play(); if (--m_ID < 0) m_ID = m_files-1; break;
		case 2 : g_sb[0].Play(); if (--m_players < 2) m_players = 4; break;
		case 3 : g_sb[0].Play(); m_monsters = !m_monsters; break;
		case 4 : g_sb[0].Play(); if (--m_victories < 1) m_victories = 9; break;
		case 5 : g_sb[0].Play(); if (--m_bonuslevel < 8) m_bonuslevel = MAX_BONUS_LEVEL_DEADMATCH; break;
		}
		break;
	case VK_RIGHT : 
		switch (m_sel) {
		case 1 : g_sb[0].Play(); if (++m_ID >= m_files) m_ID = 0; break;
		case 2 : g_sb[0].Play(); if (++m_players > 4) m_players = 2; break;
		case 3 : g_sb[0].Play(); m_monsters = !m_monsters; break;
		case 4 : g_sb[0].Play(); if (++m_victories >  9) m_victories = 1; break;
		case 5 : g_sb[0].Play(); if (++m_bonuslevel > MAX_BONUS_LEVEL_DEADMATCH) m_bonuslevel = 8; break;
		}
		break;
	}

	return MENU_DEFAULT;
}
