// MMrchovnik.cpp: implementation of the MMrchovnik class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MMrchovnik.h"
#include "data.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern int gmaxmrchovnik;

const int to_P_mrcha[] =
{
	-1, 0, 1, 2, 7, 6, 8, 14, 4, 9, 3, 10,
};

const int id_to_IQ[] =
{
	-10, 5, 20, 50, 0, 50, 50, 50, 0, 0,
};

MMrchovnik::MMrchovnik()
{
	m_sel = 0;
	m_bMrcha = -1;
}

MMrchovnik::~MMrchovnik()
{

}

void MMrchovnik::Destroy()
{
	if (m_bMrcha != -1) d3dx.DestroyTexture(m_bMrcha);
	m_bMrcha = -1;
}

void MMrchovnik::Draw()
{
	if (m_bMrcha != -1)
		d3dx.Draw(m_bMrcha, 400, 300, 0, 1.5625);

// popisky mrch
	m_font->DrawTextScaled( 25, 125,  0.9f, 1, 1, 0xffffffff, lng.Translate(100+m_sel), D3DFONT_FILTERED);
	m_fontL->DrawTextScaled( 25, 420,  0.9f, 1, 1, 0xffffffff, lng.Translate(120+m_sel), D3DFONT_FILTERED);


// IQ
	m_font->DrawTextScaled( 25, 320,  0.9f, 1, 1, 0xffffffff, lng.Translate(61), D3DFONT_FILTERED);
	if (m_sel != 0) {
		CString s;
		s.Format("%d", id_to_IQ[P_mrcha[to_P_mrcha[m_sel]].ai]);
		m_fontL->DrawTextScaled( 268, 324,  0.9f, 1, 1, 0xffffffff, s, D3DFONT_FILTERED);
	}
	else {
		m_fontL->DrawTextScaled( 268, 324,  0.9f, 1, 1, 0xffffffff, lng.Translate(62), D3DFONT_FILTERED);
	}

// Rychlost
	m_font->DrawTextScaled( 25, 350,  0.9f, 1, 1, 0xffffffff, lng.Translate(60), D3DFONT_FILTERED);
	if (m_sel != 0) {
		CString s;
		s.Format("%.0f", P_mrcha[to_P_mrcha[m_sel]].speed);
		m_fontL->DrawTextScaled( 268, 354,  0.9f, 1, 1, 0xffffffff, s, D3DFONT_FILTERED);
	}
	else {
		CString s;
		s.Format("%.0f", P_bomber.speed);
		m_fontL->DrawTextScaled( 268, 354,  0.9f, 1, 1, 0xffffffff, s, D3DFONT_FILTERED);
	}

	// Zivoty
	m_font->DrawTextScaled( 25, 380,  0.9f, 1, 1, 0xffffffff, lng.Translate(63), D3DFONT_FILTERED);
	if (m_sel != 0) {
		CString s;
		s.Format("%d", P_mrcha[to_P_mrcha[m_sel]].lives);
		m_fontL->DrawTextScaled( 268, 384,  0.9f, 1, 1, 0xffffffff, s, D3DFONT_FILTERED);
	}
	else {
		m_fontL->DrawTextScaled( 268, 384,  0.9f, 1, 1, 0xffffffff, "1", D3DFONT_FILTERED);
	}

}

void MMrchovnik::Init(CMainFrame *parent)
{
	GBase::Init(parent);

	m_max_sel = gmaxmrchovnik;
	LoadMrcha();
}

int MMrchovnik::OnKey(int nChar)
{
	switch (nChar) {
	case VK_RIGHT :
	case 40 : if (++m_sel > m_max_sel) m_sel = 0; LoadMrcha(); g_sb[0].Play(); break;
	case VK_LEFT :
	case 38 : if (--m_sel < 0) m_sel = m_max_sel; LoadMrcha(); g_sb[0].Play(); break;
	case 27 : 
	case VK_RETURN : 
	case VK_SPACE :
		return MENU_MAIN; 
		break;
	}

	return MENU_DEFAULT;
}

void MMrchovnik::LoadMrcha()
{
	if (m_bMrcha != -1) d3dx.DestroyTexture(m_bMrcha);
	CString s;
	s.Format("data\\mrchovnik%d.jpg", m_sel);
	m_bMrcha = d3dx.CreateTextureFromFile(s);
}
