// MSingle.cpp: implementation of the MSingle class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "D3DXApp.h"
#include "MSingle.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MSingle::MSingle()
{

}

MSingle::~MSingle()
{

}

void MSingle::Init(CMainFrame *parent)
{
	GBase::Init(parent);

	m_bDeadBMP = d3dx.CreateTextureFromRes(gfx_modules, "menudead.bmp");
	m_bDead = d3dx.CreateVirualTexture(m_bDeadBMP, 1, 1, 50, 70);

	m_code = "";
	m_sel = 0;
	m_players = 1;
	m_bPozadi = d3dx.CreateTextureFromFile("data\\mstory.jpg");
}

void MSingle::Destroy()
{
	d3dx.DestroyTexture(m_bDeadBMP);
	d3dx.DestroyTexture(m_bDead);
	if (m_bPozadi != -1) d3dx.DestroyTexture(m_bPozadi);
	m_bPozadi = -1;
}

void MSingle::Draw()
{
	int i;

	d3dx.Draw(m_bPozadi, 400, 300, 0, 1.5625);


	for (i = 0; i < m_players; i++)
		d3dx.Draw(m_bDead, 400-30*(m_players-1)+i*60, 200, 0, 1, 1, 128, 0, 1);
	for (i = 0; i < m_players; i++)
		d3dx.Draw(m_bDead, 400-30*(m_players-1)+i*60, 200, 0, 1, 1, 255, i);

	if (m_sel == 0) m_font->DrawTextScaled( 400, 290,  0.9f, 1, 1, 0xffffffff, _LNG_SINGLE_START_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 290,  0.9f, 1, 1, 0xffaaaaaa, _LNG_SINGLE_START_, D3DFONT_FILTERED | D3DFONT_CENTERED);

	if (m_sel == 1) m_font->DrawTextScaled( 400, 330,  0.9f, 1, 1, 0xffffffff, _LNG_SINGLE_PLAYERS_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 330,  0.9f, 1, 1, 0xffaaaaaa, _LNG_SINGLE_PLAYERS_, D3DFONT_FILTERED | D3DFONT_CENTERED);

	CString s;
	if (m_sel == 2) {
		s.Format("%s : %s_",_LNG_SINGLE_CODE_, m_code);
		m_font->DrawTextScaled( 400, 370,  0.9f, 1, 1, 0xffffffff, s, D3DFONT_FILTERED | D3DFONT_CENTERED);
	}
	else {
		s.Format("%s : %s",_LNG_SINGLE_CODE_, m_code);
		m_font->DrawTextScaled( 400, 370,  0.9f, 1, 1, 0xffaaaaaa, s, D3DFONT_FILTERED | D3DFONT_CENTERED);
	}

	if (m_sel == 3) m_font->DrawTextScaled( 400, 410,  0.9f, 1, 1, 0xffffffff, _LNG_SINGLE_BACK_, D3DFONT_FILTERED | D3DFONT_CENTERED);
	else            m_font->DrawTextScaled( 400, 410,  0.9f, 1, 1, 0xffaaaaaa, _LNG_SINGLE_BACK_, D3DFONT_FILTERED | D3DFONT_CENTERED);
}

int MSingle::OnKey(int nChar)
{
	switch (nChar) {
	case 40 : if (++m_sel > MAX_SINGLE_SEL-1) m_sel = 0;  g_sb[0].Play(); break;
	case 38 : if (--m_sel < 0) m_sel = MAX_SINGLE_SEL-1;  g_sb[0].Play(); break;
	case 27 : return MENU_MAIN; break;
	case VK_SPACE :
	case VK_RETURN : 
		switch (m_sel) {
		case 2 : 
		case 0 : return MENU_SINGLEPLAYING; break;
		case 1 : g_sb[0].Play(); if (++m_players > 4) m_players = 1; break;
		case 3 : return MENU_MAIN; break;
		}
		break;
	case VK_LEFT : 
		switch (m_sel) {
		case 1 : g_sb[0].Play(); if (--m_players < 1) m_players = 4; break;
		}
		break;
	case VK_RIGHT : 
		switch (m_sel) {
		case 1 : g_sb[0].Play(); if (++m_players > 4) m_players = 1; break;
		}
		break;
	case VK_DELETE:
	case VK_CLEAR:
	case VK_BACK:
		if (!m_code.IsEmpty()) {
			m_code.Delete(m_code.GetLength()-1);
			g_sb[9].Play();
		}
		break;
	default:
		if (nChar >= 'A' && nChar <= 'Z' && m_sel == 2)
			if (m_code.GetLength() < 6) { 
				m_code += nChar;
				g_sb[9].Play();
			}		
	}

	return MENU_DEFAULT;

}
