// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__20FF487E_BC0C_4B01_A038_0FBF3E204308__INCLUDED_)
#define AFX_MAINFRM_H__20FF487E_BC0C_4B01_A038_0FBF3E204308__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GBase.h"
#include "GGame.h"
#include "MMenu.h"
#include "MIntro.h"
#include "D3DFont.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

	HDShow intro;

// Attributes
public:

	GGame     m_game;
	MMenu     m_menu;
	MIntro    m_intro;

	GBase    *m_actual;
	CD3DFont *m_font;
	CD3DFont *m_fontL;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	//}}AFX_VIRTUAL

// Implementation
public:
	void StartIntro();
	void StartMenu();
	void StartGame(CString file, int players, bool deadmatch, bool monsters, int bonuslevel);
	void InitGame();
	void OnGraphEvent(int para, int parb);
	void Draw();
	void Move();
	void OnInit(int parama, int paramb);
	virtual ~CMainFrame();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


	HDSoundBuffer m_sb;

	int   m_tmr;

	HCURSOR m_cursor;
// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__20FF487E_BC0C_4B01_A038_0FBF3E204308__INCLUDED_)
